%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Summary:   A thread-safe version of Tkinter
Name:      python-mtTkinter
Version:   0.4
Release:   9%{?dist}
License:   LGPLv3+
Source0:   http://tkinter.unpythonic.net/attach/mtTkinter/attachments/mtTkinter-%{version}.tar.gz
Source1:   08-clock-bezier.py
Group:     Development/Languages
URL:       http://tkinter.unpythonic.net/wiki/mtTkinter
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python-devel >= 2.4
Requires:  tkinter
BuildArch: noarch

%description
Although Tkinter is technically thread-safe 
(assuming Tk is built with --enable-threads), 
practically speaking there are still problems when used in multithreaded 
Python applications.  The problems stem from the fact that the _tkinter 
module attempts to gain control of the main thread via a polling technique 
when processing calls from other threads.  If it succeeds, all is well. 
If it fails (i.e., after a timeout), the application receives an exception 
with the message: "RuntimeError: main thread is not in main loop". 
There is no way to tell when this might happen, so calling Tk routines 
from multiple threads seems to be problematic at best.

The mtTkinter module solves this problem by modifying some Tkinter 
module definitions (in memory). The modified code intercepts 
out-of-thread Tkinter calls and marshals them through a queue which 
is read by an 'after' event running periodically in the main loop. 
This is similar to the technique used in many other platforms 
(e.g., .NET's InvokeRequired/Invoke mechanism). 
The technique used in mtTkinter is exception-safe as well, 
marshaling exceptions through a response queue back to the caller's thread. 

%prep
%setup -q -n mtTkinter-%{version}

%build

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{python_sitelib}
install -pm 0644 %{_builddir}/mtTkinter-%{version}/mtTkinter.py %{buildroot}%{python_sitelib}/
install -pm 0644 %{SOURCE1} %{_builddir}/mtTkinter-%{version}/clock-bezier.py

%clean
rm -rf %{buildroot}

%files 
%defattr(-,root,root,-)
%doc clock-bezier.py lgpl.txt gpl.txt
%{python_sitelib}/mtTkinter.py*

%changelog
* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild


* Sun Aug 28 2011 Paulo Roma <roma@lcg.ufrj.br> 0.4-3
- Chmod mtTkinter.py to 0644

* Sun Aug 14 2011 Paulo Roma <roma@lcg.ufrj.br> 0.4-2
- Changed license to LGPLv3+

* Fri Jan 13 2011 Paulo Roma <roma@lcg.ufrj.br> 0.4-1
- Updated to 0.4
- Changed license.

* Sat Oct 23 2010 Paulo Roma <roma@lcg.ufrj.br> 0.3-2
- Added BR python-devel.

* Mon Feb 01 2010 Paulo Roma <roma@lcg.ufrj.br> 0.3-1
- Initial spec file.

